<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tactic Arena: include/SDL/SDL_cpuinfo.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="icon.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tactic Arena
   </div>
   <div id="projectbrief">Reproduction of Tactic Arena with Custom features</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_bb71c587d4eee030bda30f2f35ebd6b7.html">SDL</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">SDL_cpuinfo.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="_s_d_l__stdinc_8h_source.html">SDL_stdinc.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="begin__code_8h_source.html">begin_code.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="close__code_8h_source.html">close_code.h</a>&quot;</code><br />
</div>
<p><a href="_s_d_l__cpuinfo_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a05d74b2aab28d821ea7f3f78372fd00e"><td class="memItemLeft" align="right" valign="top"><a id="a05d74b2aab28d821ea7f3f78372fd00e"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>SDL_CACHELINE_SIZE</b>&#160;&#160;&#160;128</td></tr>
<tr class="separator:a05d74b2aab28d821ea7f3f78372fd00e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a888cf77e53a67803402e1740a9639bd7"><td class="memItemLeft" align="right" valign="top">DECLSPEC int SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a888cf77e53a67803402e1740a9639bd7">SDL_GetCPUCount</a> (void)</td></tr>
<tr class="separator:a888cf77e53a67803402e1740a9639bd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa699924d6c33d2cac8f1983c4ae4091c"><td class="memItemLeft" align="right" valign="top">DECLSPEC int SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aa699924d6c33d2cac8f1983c4ae4091c">SDL_GetCPUCacheLineSize</a> (void)</td></tr>
<tr class="separator:aa699924d6c33d2cac8f1983c4ae4091c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afea666a39b6be7821303adcf16e83c47"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#afea666a39b6be7821303adcf16e83c47">SDL_HasRDTSC</a> (void)</td></tr>
<tr class="separator:afea666a39b6be7821303adcf16e83c47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bc2024dc37b1d318eb197c161f8e50b"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a9bc2024dc37b1d318eb197c161f8e50b">SDL_HasAltiVec</a> (void)</td></tr>
<tr class="separator:a9bc2024dc37b1d318eb197c161f8e50b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecec2f1434aa2eb5c82f974880f5181f"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aecec2f1434aa2eb5c82f974880f5181f">SDL_HasMMX</a> (void)</td></tr>
<tr class="separator:aecec2f1434aa2eb5c82f974880f5181f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57efd279a93553cf43a54e3a49db6305"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a57efd279a93553cf43a54e3a49db6305">SDL_Has3DNow</a> (void)</td></tr>
<tr class="separator:a57efd279a93553cf43a54e3a49db6305"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed4b71a601e3a12786a5280f59c0e26d"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aed4b71a601e3a12786a5280f59c0e26d">SDL_HasSSE</a> (void)</td></tr>
<tr class="separator:aed4b71a601e3a12786a5280f59c0e26d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadc66ce3d29c669f6c78ee17c592336e"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aadc66ce3d29c669f6c78ee17c592336e">SDL_HasSSE2</a> (void)</td></tr>
<tr class="separator:aadc66ce3d29c669f6c78ee17c592336e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0dfbc5d529ba0b65d1fff744da69f5e"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#ab0dfbc5d529ba0b65d1fff744da69f5e">SDL_HasSSE3</a> (void)</td></tr>
<tr class="separator:ab0dfbc5d529ba0b65d1fff744da69f5e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6719853bee3dd03b8823540705a55932"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a6719853bee3dd03b8823540705a55932">SDL_HasSSE41</a> (void)</td></tr>
<tr class="separator:a6719853bee3dd03b8823540705a55932"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fea35e1593bb7981cdc1da4d0b2dccb"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a9fea35e1593bb7981cdc1da4d0b2dccb">SDL_HasSSE42</a> (void)</td></tr>
<tr class="separator:a9fea35e1593bb7981cdc1da4d0b2dccb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec739a6c622987314d9a22899c4ba673"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aec739a6c622987314d9a22899c4ba673">SDL_HasAVX</a> (void)</td></tr>
<tr class="separator:aec739a6c622987314d9a22899c4ba673"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fa7d982a27fb5a29fc1b291fc1054f4"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a1fa7d982a27fb5a29fc1b291fc1054f4">SDL_HasAVX2</a> (void)</td></tr>
<tr class="separator:a1fa7d982a27fb5a29fc1b291fc1054f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5108ee8d59a6d8a0a978f96b799bd3b1"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a5108ee8d59a6d8a0a978f96b799bd3b1">SDL_HasAVX512F</a> (void)</td></tr>
<tr class="separator:a5108ee8d59a6d8a0a978f96b799bd3b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5356bc82108c60c3bee504ee63fda7e"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#aa5356bc82108c60c3bee504ee63fda7e">SDL_HasARMSIMD</a> (void)</td></tr>
<tr class="separator:aa5356bc82108c60c3bee504ee63fda7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5096ea77af07eb4a9d4c754289b2a2b"><td class="memItemLeft" align="right" valign="top">DECLSPEC SDL_bool SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#ac5096ea77af07eb4a9d4c754289b2a2b">SDL_HasNEON</a> (void)</td></tr>
<tr class="separator:ac5096ea77af07eb4a9d4c754289b2a2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af672834675f296bed0e226113695bebd"><td class="memItemLeft" align="right" valign="top">DECLSPEC int SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#af672834675f296bed0e226113695bebd">SDL_GetSystemRAM</a> (void)</td></tr>
<tr class="separator:af672834675f296bed0e226113695bebd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99cf6527faa408c398a5a678aaf892d5"><td class="memItemLeft" align="right" valign="top">DECLSPEC size_t SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a99cf6527faa408c398a5a678aaf892d5">SDL_SIMDGetAlignment</a> (void)</td></tr>
<tr class="memdesc:a99cf6527faa408c398a5a678aaf892d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Report the alignment this system needs for SIMD allocations.  <a href="_s_d_l__cpuinfo_8h.html#a99cf6527faa408c398a5a678aaf892d5">More...</a><br /></td></tr>
<tr class="separator:a99cf6527faa408c398a5a678aaf892d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90747fee878a98aaba20e615f749308b"><td class="memItemLeft" align="right" valign="top">DECLSPEC void *SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b">SDL_SIMDAlloc</a> (const size_t len)</td></tr>
<tr class="memdesc:a90747fee878a98aaba20e615f749308b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory in a SIMD-friendly way.  <a href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b">More...</a><br /></td></tr>
<tr class="separator:a90747fee878a98aaba20e615f749308b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af533acf5c60f71bcefef0d8cea9dae99"><td class="memItemLeft" align="right" valign="top">DECLSPEC void *SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#af533acf5c60f71bcefef0d8cea9dae99">SDL_SIMDRealloc</a> (void *mem, const size_t len)</td></tr>
<tr class="memdesc:af533acf5c60f71bcefef0d8cea9dae99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reallocate memory obtained from SDL_SIMDAlloc.  <a href="_s_d_l__cpuinfo_8h.html#af533acf5c60f71bcefef0d8cea9dae99">More...</a><br /></td></tr>
<tr class="separator:af533acf5c60f71bcefef0d8cea9dae99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bd4b538ff298ee8f2c31ed9da3253d4"><td class="memItemLeft" align="right" valign="top">DECLSPEC void SDLCALL&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_s_d_l__cpuinfo_8h.html#a5bd4b538ff298ee8f2c31ed9da3253d4">SDL_SIMDFree</a> (void *ptr)</td></tr>
<tr class="memdesc:a5bd4b538ff298ee8f2c31ed9da3253d4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deallocate memory obtained from SDL_SIMDAlloc.  <a href="_s_d_l__cpuinfo_8h.html#a5bd4b538ff298ee8f2c31ed9da3253d4">More...</a><br /></td></tr>
<tr class="separator:a5bd4b538ff298ee8f2c31ed9da3253d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>CPU feature detection for SDL. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="aa699924d6c33d2cac8f1983c4ae4091c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa699924d6c33d2cac8f1983c4ae4091c">&#9670;&nbsp;</a></span>SDL_GetCPUCacheLineSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC int SDLCALL SDL_GetCPUCacheLineSize </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns the L1 cache line size of the CPU</p>
<p>This is useful for determining multi-threaded structure padding or SIMD prefetch sizes. </p>

</div>
</div>
<a id="a888cf77e53a67803402e1740a9639bd7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a888cf77e53a67803402e1740a9639bd7">&#9670;&nbsp;</a></span>SDL_GetCPUCount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC int SDLCALL SDL_GetCPUCount </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns the number of CPU cores available. </p>

</div>
</div>
<a id="af672834675f296bed0e226113695bebd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af672834675f296bed0e226113695bebd">&#9670;&nbsp;</a></span>SDL_GetSystemRAM()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC int SDLCALL SDL_GetSystemRAM </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns the amount of RAM configured in the system, in MB. </p>

</div>
</div>
<a id="a57efd279a93553cf43a54e3a49db6305"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a57efd279a93553cf43a54e3a49db6305">&#9670;&nbsp;</a></span>SDL_Has3DNow()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_Has3DNow </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has 3DNow! features. </p>

</div>
</div>
<a id="a9bc2024dc37b1d318eb197c161f8e50b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9bc2024dc37b1d318eb197c161f8e50b">&#9670;&nbsp;</a></span>SDL_HasAltiVec()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasAltiVec </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has AltiVec features. </p>

</div>
</div>
<a id="aa5356bc82108c60c3bee504ee63fda7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5356bc82108c60c3bee504ee63fda7e">&#9670;&nbsp;</a></span>SDL_HasARMSIMD()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasARMSIMD </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has ARM SIMD (ARMv6) features. </p>

</div>
</div>
<a id="aec739a6c622987314d9a22899c4ba673"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aec739a6c622987314d9a22899c4ba673">&#9670;&nbsp;</a></span>SDL_HasAVX()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasAVX </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has AVX features. </p>

</div>
</div>
<a id="a1fa7d982a27fb5a29fc1b291fc1054f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1fa7d982a27fb5a29fc1b291fc1054f4">&#9670;&nbsp;</a></span>SDL_HasAVX2()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasAVX2 </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has AVX2 features. </p>

</div>
</div>
<a id="a5108ee8d59a6d8a0a978f96b799bd3b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5108ee8d59a6d8a0a978f96b799bd3b1">&#9670;&nbsp;</a></span>SDL_HasAVX512F()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasAVX512F </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has AVX-512F (foundation) features. </p>

</div>
</div>
<a id="aecec2f1434aa2eb5c82f974880f5181f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aecec2f1434aa2eb5c82f974880f5181f">&#9670;&nbsp;</a></span>SDL_HasMMX()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasMMX </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has MMX features. </p>

</div>
</div>
<a id="ac5096ea77af07eb4a9d4c754289b2a2b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac5096ea77af07eb4a9d4c754289b2a2b">&#9670;&nbsp;</a></span>SDL_HasNEON()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasNEON </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has NEON (ARM SIMD) features. </p>

</div>
</div>
<a id="afea666a39b6be7821303adcf16e83c47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afea666a39b6be7821303adcf16e83c47">&#9670;&nbsp;</a></span>SDL_HasRDTSC()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasRDTSC </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has the RDTSC instruction. </p>

</div>
</div>
<a id="aed4b71a601e3a12786a5280f59c0e26d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aed4b71a601e3a12786a5280f59c0e26d">&#9670;&nbsp;</a></span>SDL_HasSSE()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasSSE </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has SSE features. </p>

</div>
</div>
<a id="aadc66ce3d29c669f6c78ee17c592336e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aadc66ce3d29c669f6c78ee17c592336e">&#9670;&nbsp;</a></span>SDL_HasSSE2()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasSSE2 </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has SSE2 features. </p>

</div>
</div>
<a id="ab0dfbc5d529ba0b65d1fff744da69f5e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0dfbc5d529ba0b65d1fff744da69f5e">&#9670;&nbsp;</a></span>SDL_HasSSE3()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasSSE3 </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has SSE3 features. </p>

</div>
</div>
<a id="a6719853bee3dd03b8823540705a55932"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6719853bee3dd03b8823540705a55932">&#9670;&nbsp;</a></span>SDL_HasSSE41()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasSSE41 </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has SSE4.1 features. </p>

</div>
</div>
<a id="a9fea35e1593bb7981cdc1da4d0b2dccb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9fea35e1593bb7981cdc1da4d0b2dccb">&#9670;&nbsp;</a></span>SDL_HasSSE42()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC SDL_bool SDLCALL SDL_HasSSE42 </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function returns true if the CPU has SSE4.2 features. </p>

</div>
</div>
<a id="a90747fee878a98aaba20e615f749308b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90747fee878a98aaba20e615f749308b">&#9670;&nbsp;</a></span>SDL_SIMDAlloc()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC void* SDLCALL SDL_SIMDAlloc </td>
          <td>(</td>
          <td class="paramtype">const size_t&#160;</td>
          <td class="paramname"><em>len</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Allocate memory in a SIMD-friendly way. </p>
<p>This will allocate a block of memory that is suitable for use with SIMD instructions. Specifically, it will be properly aligned and padded for the system's supported vector instructions.</p>
<p>The memory returned will be padded such that it is safe to read or write an incomplete vector at the end of the memory block. This can be useful so you don't have to drop back to a scalar fallback at the end of your SIMD processing loop to deal with the final elements without overflowing the allocated buffer.</p>
<p>You must free this memory with SDL_FreeSIMD(), not free() or SDL_free() or delete[], etc.</p>
<p>Note that SDL will only deal with SIMD instruction sets it is aware of; for example, SDL 2.0.8 knows that SSE wants 16-byte vectors (<a class="el" href="_s_d_l__cpuinfo_8h.html#aed4b71a601e3a12786a5280f59c0e26d">SDL_HasSSE()</a>), and AVX2 wants 32 bytes (<a class="el" href="_s_d_l__cpuinfo_8h.html#a1fa7d982a27fb5a29fc1b291fc1054f4">SDL_HasAVX2()</a>), but doesn't know that AVX-512 wants 64. To be clear: if you can't decide to use an instruction set with an SDL_Has*() function, don't use that instruction set with memory allocated through here.</p>
<p>SDL_AllocSIMD(0) will return a non-NULL pointer, assuming the system isn't out of memory.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">len</td><td>The length, in bytes, of the block to allocated. The actual allocated block might be larger due to padding, etc. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to newly-allocated block, NULL if out of memory.</dd></dl>
<dl class="section see"><dt>See also</dt><dd>SDL_SIMDAlignment </dd>
<dd>
<a class="el" href="_s_d_l__cpuinfo_8h.html#af533acf5c60f71bcefef0d8cea9dae99" title="Reallocate memory obtained from SDL_SIMDAlloc.">SDL_SIMDRealloc</a> </dd>
<dd>
<a class="el" href="_s_d_l__cpuinfo_8h.html#a5bd4b538ff298ee8f2c31ed9da3253d4" title="Deallocate memory obtained from SDL_SIMDAlloc.">SDL_SIMDFree</a> </dd></dl>

</div>
</div>
<a id="a5bd4b538ff298ee8f2c31ed9da3253d4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5bd4b538ff298ee8f2c31ed9da3253d4">&#9670;&nbsp;</a></span>SDL_SIMDFree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC void SDLCALL SDL_SIMDFree </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Deallocate memory obtained from SDL_SIMDAlloc. </p>
<p>It is not valid to use this function on a pointer from anything but <a class="el" href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b" title="Allocate memory in a SIMD-friendly way.">SDL_SIMDAlloc()</a>. It can't be used on pointers from malloc, realloc, SDL_malloc, memalign, new[], etc.</p>
<p>However, SDL_SIMDFree(NULL) is a legal no-op.</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b" title="Allocate memory in a SIMD-friendly way.">SDL_SIMDAlloc</a> </dd>
<dd>
<a class="el" href="_s_d_l__cpuinfo_8h.html#af533acf5c60f71bcefef0d8cea9dae99" title="Reallocate memory obtained from SDL_SIMDAlloc.">SDL_SIMDRealloc</a> </dd></dl>

</div>
</div>
<a id="a99cf6527faa408c398a5a678aaf892d5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99cf6527faa408c398a5a678aaf892d5">&#9670;&nbsp;</a></span>SDL_SIMDGetAlignment()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC size_t SDLCALL SDL_SIMDGetAlignment </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Report the alignment this system needs for SIMD allocations. </p>
<p>This will return the minimum number of bytes to which a pointer must be aligned to be compatible with SIMD instructions on the current machine. For example, if the machine supports SSE only, it will return 16, but if it supports AVX-512F, it'll return 64 (etc). This only reports values for instruction sets SDL knows about, so if your SDL build doesn't have <a class="el" href="_s_d_l__cpuinfo_8h.html#a5108ee8d59a6d8a0a978f96b799bd3b1">SDL_HasAVX512F()</a>, then it might return 16 for the SSE support it sees and not 64 for the AVX-512 instructions that exist but SDL doesn't know about. Plan accordingly. </p>

</div>
</div>
<a id="af533acf5c60f71bcefef0d8cea9dae99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af533acf5c60f71bcefef0d8cea9dae99">&#9670;&nbsp;</a></span>SDL_SIMDRealloc()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DECLSPEC void* SDLCALL SDL_SIMDRealloc </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>mem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const size_t&#160;</td>
          <td class="paramname"><em>len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reallocate memory obtained from SDL_SIMDAlloc. </p>
<p>It is not valid to use this function on a pointer from anything but <a class="el" href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b" title="Allocate memory in a SIMD-friendly way.">SDL_SIMDAlloc()</a>. It can't be used on pointers from malloc, realloc, SDL_malloc, memalign, new[], etc.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">mem</td><td>The pointer obtained from SDL_SIMDAlloc. This function also accepts NULL, at which point this function is the same as calling SDL_realloc with a NULL pointer. </td></tr>
    <tr><td class="paramname">len</td><td>The length, in bytes, of the block to allocated. The actual allocated block might be larger due to padding, etc. Passing 0 will return a non-NULL pointer, assuming the system isn't out of memory. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to newly-reallocated block, NULL if out of memory.</dd></dl>
<dl class="section see"><dt>See also</dt><dd>SDL_SIMDAlignment </dd>
<dd>
<a class="el" href="_s_d_l__cpuinfo_8h.html#a90747fee878a98aaba20e615f749308b" title="Allocate memory in a SIMD-friendly way.">SDL_SIMDAlloc</a> </dd>
<dd>
<a class="el" href="_s_d_l__cpuinfo_8h.html#a5bd4b538ff298ee8f2c31ed9da3253d4" title="Deallocate memory obtained from SDL_SIMDAlloc.">SDL_SIMDFree</a> </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
